/***********************************************/
/* Parser para o protocolo HTTP                */
/*                                             */
/* Eleri Cardozo, Fev 2003                     */
/* Rev. Fev 2007: trata LF                     */
/* Rev. Jul 2008: destrutor nas struts (fpinho)*/
/***********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

/* parametro http */
struct http_parametro {
    http_parametro();            /* construtor */ 
    ~http_parametro();           /* destrutor */
    char *nome;                  /* nome do parametro */
    int nvalores;                /* numero de valores associados */
    char **valores;              /* array de valores */
    http_parametro *proximo;     /* ponteiro para o proximo parametro */
    http_parametro *anterior;    /* ponteiro para parametro anterior */
};


/* cabecalho http */
struct http_cabecalho {
    http_cabecalho();            /* construtor */ 
    ~http_cabecalho();           /* destrutor */ 
    char *operacao;              /* operacao: GET, POST, ... */
    char *recurso;               /* recurso (arquivo requisitado) */
    char *cgi_pars;              /* parametros cgi */
    char *versao;                /* versao do protocolo HTTP */
    http_parametro *primeiro;    /* ponteiro para o primeiro parametro */
    http_parametro *ultimo;      /* ponteiro para o ultimo parametro */
};


/* linha do cabecalho */
struct linha_cab
{
    linha_cab();
    ~linha_cab();
    
    char *linha;                 /* linha */
    int tamanho;                 /* tamanho da linha (sem \0) */
};


/* le linha do cabecalho */
linha_cab* read_linha_cab(int file);

/* funcao que processa a primeira linha do cabecalho */
int primeira_linha(http_cabecalho *h, char *linha);

/* funcao que processa parametros do cabecalho  */
int http_par(http_cabecalho *hddr, char *linha);

/* funcao que imprime o cabecalho processado */
void imprime_cabecalho(http_cabecalho *hddr, int file_out);

